/******************************************************************************
 *
 * TAPE2FILE - convert a simh mag tape image to normal file.
 *
 * Mainly useful for converting FST or TAR archives
 *
 * Ken Cornetet - ken@cornetet.org
 *
 * Usage: tape2file InputFile OutputFile
 *
 * This is public domain code. You may use this file for any purpose you choose.
 *
 *                       WARNING! WARNING! WARNING!
 * 
 * This only works on little-endian CPUs! Easy to fix, but I am lazy...
 *
 *
 ******************************************************************************/



#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <memory.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

#ifndef O_BINARY
#define O_BINARY 0
#endif


main( int argc, char **argv )
{
	int i, fdin, fdout;

	char ibuf[32767];

    int reclen1, reclen2;

	if( (fdin = open(argv[1], O_RDONLY|O_BINARY)) < 0 ) {
		perror(argv[1]);
		exit(1);
	}

	if( (fdout = open(argv[2], O_RDWR|O_BINARY|O_CREAT)) < 0 ) {
		perror(argv[2]);
		exit(1);
	}


	while( 1 ) {
		read(fdin, &reclen1, 4);
		if(  reclen1 == 0 ) {
			break;
		}
		
		read(fdin, ibuf, reclen1);
		read(fdin, &reclen2, 4);

		if( reclen1 != reclen2 ) {
			printf("reclen1: %d  reclen2: %d\n", reclen1, reclen2);
			exit(1);
		}
		
        write(fdout, ibuf, reclen1);
	}

	close(fdin);
    close(fdout);
}

